print 'program startuje...'
import socket
import RPi.GPIO as GPIO
from struct import unpack,pack
from os import listdir
from time import sleep, time
from gpiozero import Motor
from numpy import sign

from motor_rizeni_funkce import *

'''
hlavicky funkci:
motor_rozjezd(f_motor,f_rychlost,f_predchozi_rychlost) ... laditelna
motor_ctrl(f_motor, rychlost, f_predchozi_rychlost, cas)
udp_prijem_cisla(socket)
'''
print('knihovny nacteny')


# porty pro UDP
HOST = '' # poslech na vsech interface
port_rychlost = 14550
port_zataceni = 14551
PC_port = 25000


# vytvoreni objektu pro UDP prijem a odesilani
# AF_INET ... internet, SOCK_DGRAM ... UDP
sock_rychlost = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock_zataceni = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)


# pokud nedostane nova data, vyvola vyjimku
timetout_cas = 0.5 # sec
sock_rychlost.settimeout(timetout_cas)
sock_zataceni.settimeout(timetout_cas)

# svazani socketu s adresou a portem
sock_rychlost.bind((HOST, port_rychlost))
sock_zataceni.bind((HOST, port_zataceni))

print('socket vytvoren')


# inicializace tlacitka pro zastaveni programu
STOP = 0

#   funkce volana pri interruptu
def stiskTlacitka(channel):
    # globalni promennou pro zapis nutno volat pres global
    global STOP
    STOP = 1

#   nastaveni pouziteho pinu
GPIO.setup(26, GPIO.IN, pull_up_down=GPIO.PUD_UP)

# detekce udalosti
GPIO.add_event_detect(26, GPIO.RISING, callback=stiskTlacitka, bouncetime=150)


predchozi_rychlost = 0
# inicializace motoru
pohon = Motor(27,22) #motor(dopredu,dozadu)
print("motor vytvoren")

# telo programu
try:
    while not STOP:
        # prijem hodnot pro rychlost a zataceni
        zatoceni = udp_prijem_cisla(sock_zataceni)
        rychlost = udp_prijem_cisla(sock_rychlost)
        print("rychlost: ",rychlost," zatoceni: ",zatoceni)

        try:
            motor_ctrl(pohon,rychlost,predchozi_rychlost,0)
        except Exception as e:
            print('\n chyba nastaveni rychlosti \n ',e,'\n')

        predchozi_rychlost=rychlost
    else: # provede se pri nesplenni podminky while cyklu
        print('\n ukonceno tlacitkem. \n')
except KeyboardInterrupt:
    print('\n ukonceno stiskem ctrl+c. \n') # ukonceni stiskem CTRL+C
except Exception as e:
    print('\n----------- \n Chyba: \n')
    print(e) # vypsani pripadne chyby
    print('-----------\n')
finally:
    # uklizeni pri ukonceni
    sock_rychlost.close()
    sock_zataceni.close()
    pohon.close()
    GPIO.cleanup()
