import socket
from struct import unpack
from serial import Serial
from os import listdir
from time import sleep, time
from gpiozero import Motor
import RPi.GPIO as GPIO
from numpy import sign


def motor_rozjezd(f_motor,f_rychlost,f_predchozi_rychlost):
    ''' Funkce pro rozjezd.
    '''
    pocet_kroku=10.0
    cas_rozjezdu = 2 # [s]
    cas_na_zastaveni = 2 # [s]
    krok_rozjezdu = cas_rozjezdu/(pocet_kroku-1) # [s]

    # smer zadane rychlosti a jeji velikost
    smer = sign(f_rychlost)
    f_rychlost=abs(f_rychlost)

    # vypocet zrychleni
    aktualni_hodnota=f_predchozi_rychlost
    if sign(f_predchozi_rychlost) == -smer:
        # pokud se lisi smer, motor se nejprve zastavi
        f_motor.stop()
        aktualni_hodnota=0
        sleep(cas_na_zastaveni)
        # vypocteni zrychleni pro rozjezd
        zrychleni_za_krok = abs(f_rychlost)/pocet_kroku
    else:
        # vypocet zrychelni pro zmenu rychlosti
        zrychleni_za_krok = (abs(f_rychlost)-abs(f_predchozi_rychlost))/pocet_kroku
        aktualni_hodnota=abs(f_predchozi_rychlost)

    # rozjizdeni po zadanou dobu
    t_poc = time() # sekund
    while (time() - t_poc) < cas_rozjezdu:
        if smer == 1:
            print "rozjezd: ",aktualni_hodnota
            f_motor.forward(aktualni_hodnota)
        elif smer == -1:
            print "rozjezd: ",aktualni_hodnota
            f_motor.backward(aktualni_hodnota)
        else:
            # ukonceni funkce pri neocekavane hodnote
            return None
        aktualni_hodnota += zrychleni_za_krok
        sleep(krok_rozjezdu)
    # ukonceni funkce po provedeni
    return None


def motor_ctrl(f_motor, rychlost, f_predchozi_rychlost, cas):
    '''Funkce pro nastaveni rychlosti motoru.
    Funkce vola funkci motor_rozjezd().
    '''
    # pokud dostane neocekavanou hodnotu, tak se motor zastavi
    if (rychlost<-1) or (rychlost >1):
        f_motor.stop()
    elif rychlost>0:
        # pokud se zmena rychlosti lisi o urcitou hodnotu nebo znamenkem,
        # zavola se funkce motor_rozjezd
        if (sign(rychlost) != sign(f_predchozi_rychlost)) or ((abs(rychlost)-abs(f_predchozi_rychlost)) > 0.4):
            motor_rozjezd(f_motor, rychlost, f_predchozi_rychlost)
        f_motor.forward(rychlost)
    elif rychlost<0:
        if (sign(rychlost) != sign(f_predchozi_rychlost)) or ((abs(rychlost)-abs(f_predchozi_rychlost)) > 0.4):
            motor_rozjezd(f_motor, rychlost, f_predchozi_rychlost)
        f_motor.backward(abs(rychlost))
    else:
        f_motor.stop()


def udp_prijem_cisla(sock):
    '''Funkce ze socketu prijme jedno cislo typu double.
    '''
    # prijmuti packetu ze socketu
    data,adresa = sock.recvfrom(256)
    # rozbaleni packetu ocekavaneho typu double
    data = unpack('d',data)
    return data[0]
