print 'program startuje...'
import socket
from struct import unpack,pack
from serial import Serial
from os import listdir
from time import sleep, time
import RPi.GPIO as GPIO
from numpy import sign

from raspberry_rizeni_funkce import *


'''
hlavicky funkci:
posli_arduinu(serial,natoceni,rychlost)

udp_prijem_cisla(socket)
vzdalenost(trigger, echo), vystup: milimetry


pouzite piny:
echo GPIO24
trigger GPIO23
button GPIO21
relay GPIO26,GPIO20,GPIO19,GPIO16

'''
print 'knihovny nacteny'


# porty pro UDP
HOST = '' # poslech na vsech interface
port_rychlost = 14550
port_zataceni = 14551
port_doba = 14552
PC_ip_adresa = '192.168.1.248'
PC_port = 25000


# vytvoreni objektu pro UDP prijem a odesilani
# AF_INET ... internet, SOCK_DGRAM ... UDP
sock_rychlost = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock_zataceni = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock_pc = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)


# pokud nedostane nova data, vyvola vyjimku
timetout_cas = 0.5 # sec
sock_rychlost.settimeout(timetout_cas)
sock_zataceni.settimeout(timetout_cas)

# svazani socketu s adresou a portem
sock_rychlost.bind((HOST, port_rychlost))
sock_zataceni.bind((HOST, port_zataceni))

print 'socket vytvoren'

# nastaveni cislovani pinu
GPIO.setmode(GPIO.BCM)

# inicializace dalkomeru
vzdalenost_pro_zastaveni = 500 # mm
pin_trigger = 23
pin_echo = 24
GPIO.setup(pin_trigger,GPIO.OUT)
GPIO.setup(pin_echo,GPIO.IN)
GPIO.output(pin_trigger,False)
vzdalenost_hodnota = 0

# incializace rele
pin_rele = [26,20,19,16]
GPIO.setup(pin_rele,GPIO.OUT)
GPIO.output(pin_rele,False)

# pin, ke kteremu je tlacitko pripojeno
pin_tlacitka = 21

# inicializace tlacitka pro zastaveni programu
STOP = 0

#   funkce volana pri interruptu
def stiskTlacitka(channel):
    # globalni promennou pro zapis nutno volat pres global
    global STOP
    STOP = 1
    GPIO.output(pin_rele,True)

#   nastaveni pouziteho pinu s pull-up resistorem
GPIO.setup(pin_tlacitka, GPIO.IN, pull_up_down=GPIO.PUD_UP)

# detekce udalosti
GPIO.add_event_detect(pin_tlacitka, GPIO.RISING, callback=stiskTlacitka, bouncetime=150)


# telo programu
try:
    # pripojeni k Arduinu
    #   overeni existence '/dev/ttyUSB0' ~~ COM port arduina
    seznam_zarizeni = listdir('/dev/')
    if 'ttyUSB0' in seznam_zarizeni:
        cesta = '/dev/ttyUSB0'
    elif 'ttyUSB1' in seznam_zarizeni:
        cesta = '/dev/ttyUSB1'
    else:
        raise Exception('arduino nepripojeno')

    #   pripojeni k arduinu pres seriovou linku
    try:
        arduino = Serial(cesta,timeout=0,baudrate=9600)
        print 'arduino vytvoreno'
        # prvotni nastaveni arduina a sepnuti rele
        cas = time()
        while time()-cas < 1:
            posli_arduinu(arduino,0,0)
    except Exception as e:
        raise Exception(e)

    # sepnuti rele
    GPIO.output(pin_rele,False)
    while not STOP:
        # prijem hodnot pro rychlost a zataceni
        try:
            zatoceni = udp_prijem_cisla(sock_zataceni)
        except Exception as e:
            print '\n chyba prijmu zatoceni \n',e,'\n'
            zatoceni = 0
        try:
            rychlost = udp_prijem_cisla(sock_rychlost)
        except Exception as e:
            print '\n chyba prijmu rychlosti \n',e,'\n'
            rychlost = 0
        print "rychlost: ",rychlost," zatoceni: ",zatoceni

        # pokud je pred autem prekazka, nastavi se rychlost na nulu
        try:
            vzdalenost_hodnota = vzdalenost(pin_trigger, pin_echo)
        except Exception as e:
            print '\n chyba mereni vzdalenosti \n',e,'\n'
            rychlost = 0

        if vzdalenost_hodnota<vzdalenost_pro_zastaveni:
            rychlost = 0
            print 'prekazka: ',vzdalenost_hodnota,' mm, rychlost = 0'

        sock_pc.sendto(pack('d',vzdalenost_hodnota), (PC_ip_adresa, PC_port))

        # poslani hodnoty zatoceni do arduina
        try:
            posli_arduinu(arduino,zatoceni,rychlost)
        except Exception as e:
            print '\n chyba arduina \n ',e,'\n'
            GPIO.output(pin_rele,True)

        predchozi_rychlost=rychlost
    else: # provede se pri nesplneni podminky while cyklu
        print '\n ukonceno tlacitkem. \n'
except KeyboardInterrupt:
    print '\n ukonceno stiskem ctrl+c. \n' # ukonceni stiskem CTRL+C
    GPIO.output(pin_rele,True)
except Exception as e:
    print '\n----------- \n Chyba: \n'
    print(e) # vypsani pripadne chyby
    print '-----------\n'
    GPIO.output(pin_rele,True)
finally:
    GPIO.output(pin_rele,True)
    # uklizeni pri ukonceni
    sock_rychlost.close()
    sock_zataceni.close()
    sock_pc.close()
    arduino.close()
    #GPIO.cleanup()
