import socket
from struct import unpack
from serial import Serial
from os import listdir
from time import sleep, time
import RPi.GPIO as GPIO
from numpy import sign

def posli_arduinu(serial, natoceni, rychlost):
    '''Funkce pro poslani cisla arduinu pres seriovou linku.
    Format vystupu: -0.124+0.342, -1.000-1.000
    '''
    if natoceni < 0:
        # zaokrouhleni na 3 desetinna mista a prevod na string
        text1 = str(round(natoceni,3))
    else:
        # pridani znamenka nezapornemu cislu
        text1 = '+' + str(round(natoceni,3))
    # pridani nul pro dosazeni spravne delky
    while len(text1)<6:
        text1=text1+'0'

    if rychlost < 0:
        # zaokrouhleni na 3 desetinna mista a prevod na string
        text2 = str(round(rychlost,3))
    else:
        # pridani znamenka nezapornemu cislu
        text2 = '+' + str(round(rychlost,3))
    # pridani nul pro dosazeni spravne delky
    while len(text2)<6:
        text2=text2+'0'
    # spojeni dvou stringu do jednoho
    text = text1+text2

    # odeslani arduinu
    serial.write(text)


def udp_prijem_cisla(sock):
    '''Funkce ze socketu prijme jedno cislo typu double.
    '''
    # prijmuti paketu ze socketu
    data,adresa = sock.recvfrom(256)
    # rozbaleni paketu ocekavaneho typu double
    data = unpack('d',data)
    return data[0]


def vzdalenost(trigger, echo):
    '''Funkce dalkomerem zmeri vzdalenost v milimetrech.
    '''
    zacatek_pulzu=0; konec_pulzu=0
    zacatek_funkce=time()
    # ustaleni pred vyslanim pulzu
    GPIO.output(trigger,False)
    sleep(0.00001)
    GPIO.output(trigger,True)
    # trigger pro vyslani pulzu
    sleep(0.00001)
    GPIO.output(trigger,False)
    # cekani na zacatek ozveny
    while GPIO.input(echo)==0:
        zacatek_pulzu=time()
        if zacatek_pulzu-zacatek_funkce > 1:
            raise Exception('chyba dalkomeru')

    # cekani na konec ozveny
    while GPIO.input(echo)==1:
        konec_pulzu=time()
        if konec_pulzu - zacatek_pulzu > 1:
            raise Exception('chyba dalkomeru')
            
	# doba/2/rychlost_zvuku
    return round((konec_pulzu - zacatek_pulzu) *171500)
