from time import sleep, time # funkce pro casovani
from gpiozero import Motor
from numpy import sign # funkce signum

def motor_rozjezd(f_motor,f_rychlost,f_predchozi_rychlost):
    pocet_kroku=10.0
    cas_rozjezdu = 2 # [s]
    cas_na_zastaveni = 2 # [s]
    krok_rozjezdu = cas_rozjezdu/(pocet_kroku-1) # [s]

    # smer zadane rychlosti a jeji velikost
    smer = sign(f_rychlost)
    f_rychlost=abs(f_rychlost)

    # vypocet zrychleni
    aktualni_hodnota=f_predchozi_rychlost
    if sign(f_predchozi_rychlost) == -smer:
        f_motor.stop()
        aktualni_hodnota=0
        sleep(cas_na_zastaveni)
        zrychleni_za_krok = abs(f_rychlost)/pocet_kroku
    else:
        # vypocet zrychelni pro zmenu rychlosti
        zrychleni_za_krok = (abs(f_rychlost)-abs(f_predchozi_rychlost))/pocet_kroku
        aktualni_hodnota=abs(f_predchozi_rychlost)

    t_poc = time() # sekund
    while (time() - t_poc) < cas_rozjezdu:
        if smer == 1:
            f_motor.forward(aktualni_hodnota)
        elif smer == -1:
            print "aktualni rychlost: ",aktualni_hodnota
            f_motor.backward(aktualni_hodnota)
        else:
            return None
        aktualni_hodnota += zrychleni_za_krok
        sleep(krok_rozjezdu)
    return None

def motor_ctrl(f_motor, rychlost, f_predchozi_rychlost, cas):
    if (rychlost<-1) or (rychlost >1):
        f_motor.stop()
    elif rychlost>0:
        if (sign(rychlost) != sign(f_predchozi_rychlost)) or ((abs(rychlost)-abs(f_predchozi_rychlost)) > 0.4):
            motor_rozjezd(f_motor, rychlost, f_predchozi_rychlost)
        f_motor.forward(rychlost)
    elif rychlost<0:
        if (sign(rychlost) != sign(f_predchozi_rychlost)) or ((abs(rychlost)-abs(f_predchozi_rychlost)) > 0.4):
            motor_rozjezd(f_motor, rychlost, f_predchozi_rychlost)
        f_motor.backward(abs(rychlost))
    else:
        f_motor.stop()

predchozi_rychlost = 0
motor = Motor(27,22) #motor(dopredu,dozadu)
try:
    while True:
        vstup = input('zadejte rychlost:')
        motor_ctrl(motor,vstup,predchozi_rychlost,0)
        predchozi_rychlost=vstup
except KeyboardInterrupt:
    print "ukonceno." # ukonceni stiskem CTRL+C
except Exception as e:
    print(e) # vypsani pripadne chyby
finally:
    motor.close()
