import RPi.GPIO as GPIO
from time import time, sleep
import socket
from struct import pack

GPIO.setmode(GPIO.BCM)

# piny pro dalkomer
TRIG = 23
ECHO = 24

# nastaveni odpovidajicich pinu jako vstup a vystup
GPIO.setup(TRIG,GPIO.OUT)
GPIO.setup(ECHO,GPIO.IN)
# log. 0 na pin triggeru
GPIO.output(TRIG,False)

# adresy a port pro poslani vzdalenosti do PC
PC_ip_adresa = '192.168.1.248'
PC_port = 25000

# vytvoreni objektu socketu
# AF_INET ... internet, SOCK_DGRAM ... UDP
sock = socket.socket(socket.AF_INET,socket.SOCK_DGRAM) # UDP


def vzdalenost(trigger, echo):
    '''Vrati vzdalenost v mm.
    '''
    zacatek_pulzu=0; konec_pulzu=0
    # log. 0 na pin triggeru pro ustaleni
    GPIO.output(TRIG,False)
    sleep(0.0001)
    GPIO.output(trigger,True)
    # log. 1 na trigger pro vyslani pulzu
    sleep(0.00001)
    GPIO.output(trigger,False)
    # cekani na zacatek ozveny
    while GPIO.input(echo)==0:
        zacatek_pulzu=time()
    # mereni doby ozveny odpovidajici dobe putovani pulzu
    while GPIO.input(echo)==1:
        konec_pulzu=time()
	# vypocet vzdalenosti vzorcem (doba/2)/rychlost_zvuku a zaokrouhleni
    return round((konec_pulzu - zacatek_pulzu) *171500)

# zavolani funkce na zmereni vzdalenosti a vypsani vracene hodnoty
try:
    while 1:
        vzdal_hodnota = vzdalenost(TRIG, ECHO)
        print vzdal_hodnota
        # odeslani packetu
        sock.sendto(pack('d',vzdal_hodnota), (PC_ip_adresa, PC_port))
        sleep(0.5)
finally:
    # uklizeni pred ukoncemi programu
    GPIO.cleanup()
